#include "kernel.h"
#include <all.h>

int _ti89, _ti92plus;

asm("
_start:
	dc.w	_exec-_start
	dc.w	_reloc-_start
	dc.w	_reloc2-_start
	dc.w	_unreloc-_start
	dc.w	_unreloc2-_start
	dc.w	hook-_start
    dc.w	_forRAMCALLS-_start
    dc.w    _line1010-_start

_line1010:
	move.l	2(%a7),%a0
	move.w	(%a0),%d0
	cmp.w	#0xA0A1,%d0
	jbeq	asap
	cmp.w	#0xA244,%d0
	jbeq	invalid
nopb:
    move.w	0x4,%d2
    cmp.w	#0x40,%d2
    jble	exit89
    move.l	0x412088+0x28,-(%sp)
    rts
exit89:
	move.l	0x212088+0x28,-(%sp)
	rts
invalid:
	move.l	RAM_CALLS+40*4,%d0
	and.l	#0xFFF,%d0
	cmp.l	#0x200,%d0
	jblt	nopb
	tst.w	%d3
	jbne	nopb
	lea		-0x12(%a0),%a1
	cmp.l	#0x4A43670E,(%a1)
	jbne	nopb
	bra		skip_throw
asap:
skip_throw:
	lea		2(%a7),%a0
	addq.l	#2,(%a0)
	rte

_forRAMCALLS:
    dc.l	RAM_CALLS

_reloc:		; d0.w = handle
	movem.l	%d1-%d7/%a1-%a6,-(%sp)
	move.w	%d0,-(%sp)
    bsr		reloc
    addq.l	#2,%a7
	movem.l	(%sp)+,%d1-%d7/%a1-%a6
	rts

_reloc2:	; a6.l = address
	movem.l	%d1-%d7/%a1-%a6,-(%sp)
	move.l	%a6,-(%sp)
    bsr		reloc2
    addq.l	#4,%a7
	movem.l	(%sp)+,%d1-%d7/%a1-%a6
	rts

_unreloc:	; d0.w = handle
	movem.l	%d1-%d7/%a1-%a6,-(%sp)
	move.w	%d0,-(%sp)
    bsr		unreloc
    addq.l	#2,%a7
	movem.l	(%sp)+,%d1-%d7/%a1-%a6
	rts

_unreloc2:	; a6.l = address
	movem.l	%d1-%d7/%a1-%a6,-(%sp)
	move.l	%a6,-(%sp)
    bsr		unreloc2
    addq.l	#4,%sp
	movem.l	(%sp)+,%d1-%d7/%a1-%a6
	rts

_exec:		;
    move.L	(%a7),%a0
    subq.l	#4,%a0
	movem.l	%d0-%d7/%a0-%a6,-(%sp)

    tst.w	nb_modules
    jbne	no_init

	lea	RAM_CALLS+15*2*4,%a1
	lea	top_estack_,%a2
	move.l	%a2,(%a1)+
	move.l	%a2,(%a1)

	move.l	RAM_CALLS+20*2*4,%d1
	and.l	#0xFFF,%d1
	cmp.w	#0x200,%d1
	jbge	ams2_return
	move.l	44(%a7),(%a2)
	jbra	no_init
ams2_return:
	move.l	320(%a7),(%a2)


no_init:
    move.l	%a0,-(%sp)
    bsr		exec
    addq.l	#4,%sp

    tst.w	nb_modules
    jbne	no_deinit

	lea		top_estack_,%a1
	move.l	RAM_CALLS+20*2*4,%d1
	and.l	#0xFFF,%d1
	cmp.w	#0x200,%d1
	jbge	ams2
	move.l	(%a1),44(%a7)
	jbra	no_deinit
ams2:
	move.l	(%a1),320(%a7)

no_deinit:
	movem.l	(%sp)+,%d0-%d7/%a0-%a6
    addq.l	#4,%sp
	rts
		");

        // FUNCTIONS DECLARATION

void SaveHeapState(ulong HeapTable);
void RestoreHeapState(ulong HeapTable, HANDLE fold_handle);

char IsDoorsOSfile(SYM_ENTRY *file_sym);
SYM_ENTRY *cherche_lib(char *nom);
void re_archive_libs();

int reloc(HANDLE handle);
int reloc2(ASM *address);
int unreloc(HANDLE handle);
int unreloc2(ASM *address);
int exec(ASM *address);

void InitKernel();
void DeInitKernel();
int  relocation(ASM *address, char action);

void error(char *msg);
void SetSR(int newSR);

        // DATAS

long top_estack_ = 0;

extern char *error_string;
char *memory = "Not enough memory";
int nb_modules = 0;

extern anticrash_handler anticrash_handlers[NB_VECTORS];
extern ulong *saved_addresses[NB_VECTORS];
extern int anticrash_running;

uchar anticrash_addresses[NB_VECTORS] = {
    			0xC, 		// ADDRESS ERROR
                0x10,		// ILLEGAL INSTRUCTION
                0x14,		// DIV BY ZERO
                0x18,		// CHK
                0x1C,		// TRAPV
                0x20,		// PRIV VIOLATION
                0x24,		// TRACE
                0x2C,		// LINE 1111
                0x60,		// SPURIOUS
                0x7C,		// MEMORY VIOLATION
                0x80+4*5,	// TRAP 5
                0x80+4*6,	// TRAP 6
                0x80+4*7,	// TRAP 7
                0x80+4*13,	// TRAP 13
                0x80+4*14,	// TRAP 14
                0x80+4*15,	// TRAP 15 : ER_Throw
                0x78};		// STO-ON

ulong RAM_CALLS[NB_RAM_CALLS*2] =        // RAM CALLS TABLE
	{ 0, 	1,   	// calculator
      160,	240,	// lcd_width
      100,	128,	// lcd_heigth
      0x200000,	0x400000,	// rom_base
      20,	30, 	// lcd_line_bytes
      338,	337,	// left
      344,	340,    // rigth
      337,	338,    // up
      340,	344,    // down
      345,	342,	// up-rigth
      342,	345,	// down-left
      16384,8192,	// DIAMOND
      2000,	3840,	// lcd_size
      8192, 16384,	// SHIFT
      0,0,			// font
      0,0,          // return value
      0,0,			// kb_vars
      0,0,          // heap
      0,0,          // folder handle
      0,0,			// main folder handle
      0,0 };		// ROM version

#include "init.c"   		// InitKernel, DeInitKernel
#include "reloc.c"          // relocation wrapper functions
#include "unreloc.c"		// unrelocation wrapper functions
#include "relocation.c"     // main relocation/unreloaction function
#include "hook.c"			// shift-ON hook routine
#include "vat.c"			// VAT operations

void error(char *msg)  // Display an error
{
  DlgMessage ("Error !", msg, BT_OK, BT_NONE);
}

void SetSR(int newSR)  // Wrapper for OSSetSR
{
  OSSetSR(newSR);
}

int exec(ASM *address)
{
  int result;
  ulong auto_int_vectors[7];
  unsigned errCode;
  ERROR_FRAME __errFrame;

  address = (ASM *)((ulong)address & 0x3FFFF);  // make sure address is in the range [0..0x3FFFF]

  InitKernel();

  if(!(errCode=ER_catch(__errFrame)))    	    // si pas d'erreur
  {
   while (1)
   {
    memcpy(auto_int_vectors, AUTO_INTS, 7*4);	// Save the 7 auto_ints
    result = reloc2(address);
    if (result)
    {
      char string[50];
      DeInitKernel();

      switch (result)
      {
        case NOT_ENOUGH_MEM:
          error(memory);
          break;
        case LIB_NOT_FOUND:
          sprintf(string, "Library not found: %s", error_string);
          error(string);
          break;
        case WRONG_LIB_VERSION:
          sprintf(string, "Wrong library version: %s", error_string);
          error(string);
          break;
        case FILE_NOT_VALID:
          sprintf(string, "Invalid file: %s", error_string);
          error(string);
          break;
        case KERNEL_VERSION_ERROR:
          error("DoorsOS must be updated");
          break;
        case ROM_VERSION_ERROR:
          error("The ROM must be updated");
          break;
      }
	  break;
    }
	asm(" 	movem.l	%d0-%d7/%a0-%a6,-(%sp)");
    ASM_call( (void *)address + address->main_offset );		// Executes the program
	asm("  	movem.l	(%sp)+,%d0-%d7/%a0-%a6");

    result = unreloc2(address);
    DeInitKernel();
    break;
   }
   ER_success();
   return result;
  }
  else		// In case of an error
  {
  	anticrash_running = 1;
// Pop state : ints
    SetSR(0x700);
	memcpy(AUTO_INTS, auto_int_vectors, 7*4);
	SetSR(0);
// Unrelocates & run exit points
	unreloc2(address);

    DeInitKernel();

// Display error
    if (errCode == CRASH_ERROR)
      DlgMessage("Assembly error recovered by DoorsOS", error_string, BT_OK, BT_NONE);
    else
      DlgMessage("TI-OS error recovered by DoorsOS", find_error_message(errCode), BT_OK, BT_NONE);
  	anticrash_running = 0;
    return errCode;
  }
}
