#include <nostub.h>
#include <all.h>

#define KERNEL_VERSION  (unsigned short *) 0x40030
#define KERNEL_BLOCK	(unsigned short *) 0x40048

#define VECTOR_TABLE89	(unsigned long **) 0x212088
#define VECTOR_TABLE92	(unsigned long **) 0x412088
#define INTERRUPT_TABLE	(unsigned long **) 0x40000
#define RESET_VECTOR	(unsigned long *) 0x40004

int _ti89, _ti92plus;

void _main()
{
  unsigned long **rom_int_ptr, **ram_int_ptr;
  int i;
  unsigned short kernel_bloc = *KERNEL_BLOCK;
  if (!*KERNEL_VERSION)
    return;
  OSSetSR(0x700);	// ints off
  if (kernel_bloc)	// unsinstallation 'new way'
  {
    HeapFree(kernel_bloc);
    EV_hook = NULL;
  }
  else				// old style uninstallation
  {
	asm("
	    move.l	(0xC8),%a4
	    add.l	#0x2F*4,%a4
	    move.l	(%a4),%a4
	    move.l	#0x3fff4,0x10E(%a4)");
  }

  	// Re installs the old interrupts
  rom_int_ptr = *RESET_VECTOR > 0x400000 ? VECTOR_TABLE92 + 0x64/4 : VECTOR_TABLE89 + 0x64/4;
  ram_int_ptr = INTERRUPT_TABLE + 0x64/4;	// Auto int 1
  i = 7;									// 7 auto ints
  while (i--)
    *ram_int_ptr++ = *rom_int_ptr++;
  memset(INTERRUPT_TABLE + 0x30/4, 0, 0x1A);	// [0x40030..0x4004A] = 0

  OSSetSR(0);								// ints on
}
