int unreloc(HANDLE handle)
{
  return unreloc2(HeapDeref(handle)+2);
}

int unreloc_core(ASM *address)
{
  int result;

// unrelocates

  result = relocation(address, UNRELOC);
// detruit le BSS
  if (address->bss_hdl)
	HeapFree(address->bss_hdl);
  return result;
}

int unreloc2(ASM *address)
{
  int result;
  if (address >= (ASM *)0x200000)
    return ARCHIVED_FILE;
  if (  (address->sign != 0x36386B50)	 // 68kP
  	 && (address->sign != 0x36386B4C) )	 // 68kL
  	return FILE_NOT_VALID;

  if (address->relcnt == 0)			     // Already unrelocated
    return NO_ERROR;

  if (address->relocating)
    return NO_ERROR;

  if (address->relcnt != 1)              // Not to unrelocate for now
  {
    address->relcnt --;
    nb_modules --;
    return NO_ERROR;
  }

  SetSR(0x700);
  address->relocating = 1;
  result = unreloc_core(address);
  HeapUnlock(HeapPtrToHandle((void *)address-2));
  address->relocating = 0;
  SetSR(0);

  address->relcnt--;
  nb_modules--;

  return result;
}


