
typedef struct{
	ushort 	max_syms;
    ushort	nb_syms;
    SYM_ENTRY	syms;
}SYM_TABLE;

void re_archive_libs()
{
  SYM_TABLE *fold_table, *file_table;
  SYM_ENTRY *fold_sym, *file_sym;
  int i,j;

  fold_table = HeapDeref(RAM_CALLS[FOLDERLIST]);
  i = fold_table->nb_syms;
  fold_sym = &fold_table->syms;
  while (i--)
  {
    file_table = HeapDeref(fold_sym->handle);
    j = file_table->nb_syms;
    file_sym = &file_table->syms;
    while (j--)
    {
      if (IsDoorsOSfile(file_sym) && file_sym->flags.bits.local)  // unarchived library
      {
        ASM *contents = HeapDeref(file_sym->handle)+2;
        if (contents->relcnt)
          continue;
  	    HeapFree(file_sym->handle);
		file_sym->handle = file_sym->compat;
        file_sym->compat = 0;
        file_sym->flags.bits.archived = 1;
        file_sym->flags.bits.locked = 1;
        file_sym->flags.bits.local = 0;
      }
      file_sym++;
    }
    fold_sym++;
  }
}

char IsDoorsOSfile(SYM_ENTRY *file_sym)
{
  ASM *contents;
  if (file_sym->flags.bits.folder == 1)
    return 0;
  if (*HToESI(file_sym->handle) != -13)    // 0xF3
	return 0;
  contents = HeapDeref(file_sym->handle)+2;
  if ((contents->sign != 0x36386B50) &&	   // 68kP
      (contents->sign != 0x36386B4C))	   // 68kL
	return 0;
  return 1;
}

SYM_ENTRY *cherche_lib(char *nom)
{
  SYM_TABLE *fold_table, *file_table;
  SYM_ENTRY *fold_sym, *file_sym, *sym_found;
  int i,j;
  sym_found = NULL;

  fold_table = HeapDeref(RAM_CALLS[FOLDERLIST]);
  i = fold_table->nb_syms;
  fold_sym = &fold_table->syms;
  while (i--)
  {
    file_table = HeapDeref(fold_sym->handle);
    j = file_table->nb_syms;
    file_sym = &file_table->syms;
    while (j--)
    {
      if (!SymCmp(file_sym->name, nom))       // We found one file w/ this name
      {
        if (!sym_found)           // No sym found for the moment
          sym_found = file_sym;
        else
        {
          if (!IsDoorsOSfile(file_sym))
            continue;
          else if (!IsDoorsOSfile(sym_found))
            sym_found = file_sym;
          if (file_sym->flags.bits.archived == 0)
            sym_found = file_sym;
        }
        if (IsDoorsOSfile(sym_found) && (sym_found->flags.bits.archived == 0))
          return sym_found;
      }
      file_sym++;
    }
    fold_sym++;
  }
  return sym_found;
}

