        xdef _library

        xdef util@0000
        xdef util@0001
        xdef util@0002
        xdef util@0003
        xdef util@0004
        xdef util@0005
        xdef util@0006
        xdef util@0007
        xdef util@0008
        xdef util@0009
        xdef util@000A
        xdef util@000B
        xdef util@000C
        xdef util@000D
        xdef util@000E
        xdef util@000F
        xdef util@0010
        xdef util@0011
        xdef util@0012
        xdef util@0013

        include "tios.h"
	include "graphlib.h"
	include "userlib.h"

        xdef _ti92plus
        xdef _ti89

ST_busy equ $e2

pixel_do        macro
        movem.l d0-d1/a0,-(a7)

	lea	LCD_MEM,a0

        move.w  4*4+2(a7),d0            ; y-coordinate
        cmp.w   #LCD_HEIGHT,d0
	bcc	\pixel_bad
        lsl.w   #1,d0
        move.w  d0,d1
        lsl.w   #4,d0
        sub.w   d1,d0
	lea	0(a0,d0.w),a0

        move.w  4*4+0(a7),d0            ; x-coordinate
        cmp.w   #LCD_WIDTH,d0
	bcc	\pixel_bad
	move.w	d0,d1
	lsr.w	#3,d0

	not.w	d1
	and.w	#7,d1
	b\1.b	d1,0(a0,d0.w)

\pixel_bad:
        movem.l (a7)+,d0-d1/a0
		endm

;*****************************************************

find_pixel:
util@0000:
        move.w  d1,-(a7)

	lea	LCD_MEM,a0

        move.w  (4+2)+2(a7),d0          ; y-coordinate
        cmp.w   #LCD_HEIGHT,d0
        bcc     pixel_bad
        lsl.w   #1,d0
        move.w  d0,d1
        lsl.w   #4,d0
        sub.w   d1,d0
	lea	0(a0,d0.w),a0

        move.w  (4+2)+0(a7),d1          ; x-coordinate
        cmp.w   #LCD_WIDTH,d1
	bcc	pixel_bad
	move.w	d1,d0
	lsr.w	#3,d1
	lea	0(a0,d1.w),a0
	not.w	d0
	and.w	#7,d0

pixel_good:
        move.w  (a7)+,d1
	rts

pixel_bad:
	sub.l	a0,a0
	bra	pixel_good

;*****************************************************

pixel_on:
util@0001:
	pixel_do	set
	rts

;*****************************************************

pixel_off:
util@0002:
	pixel_do	clr
	rts

;*****************************************************

pixel_chg:
util@0003:
	pixel_do	chg
	rts

;*****************************************************
; prep_rect: used by frame_rect and erase_rect
;*****************************************************
prep_rect:
util@0004:
	move.l	#0,d4
        move.w  $36(a7),d4
	move.w	d4,d5
	lsl.w	#5,d4
	lsl.w	#1,d5
	sub.w	d5,d4
	add.l	#LCD_MEM,d4
	move.l	d4,a0

	move.l	#0,d5
        move.w  $3A(a7),d5
	move.w	d5,d6
	lsl.w	#5,d5
	lsl.w	#1,d6
	sub.w	d6,d5
	add.l	#LCD_MEM,d5
	move.l	d5,a1

        move.w  $34(a7),d0
	move.w	d0,d6
	lsr.w	#3,d0
	and.w	#$7,d6

        move.w  $38(a7),d1
	move.w	d1,d7
	lsr.w	#3,d1
	and.w	#$7,d7

	rts

;*****************************************************

frame_rect:
util@0005:
	jmp	graphlib::frame_rect

erase_rect:
util@0006:
	jmp	graphlib::erase_rect

;*****************************************************

show_dialog:
util@0007:
	jmp	graphlib::show_dialog

clear_dialog:
util@0008:
	jmp	graphlib::clear_dialog

clr_scr:
util@0009:
	jmp	graphlib::clr_scr2



zap_screen:
util@000A:
	jmp	graphlib::clr_scr

idle_loop:
util@000B:
	jmp	userlib::idle_loop

;*****************************************************

random:
util@000C:
        move.l  d1,-(a7)
	move.w	rand_seed(pc),d1
	mulu.w	#31421,d1
	add.w	#6927,d1
	mulu.w	d1,d0
	move.w	d1,rand_seed
	clr.w	d0
	swap	d0
        move.l  (a7)+,d1
	rts

tios::DrawCharXY
util@000D:
        move.w 4(a7),d0
        move.b d0,charstr
        move.w 6(a7),d0
        move.w 8(a7),d1
        move.w 10(a7),d2
        move.w d2,-(a7)
        move.l #charstr,-(a7)
        move.w d1,-(a7)
        move.w d0,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        rts

kernel::exec
util@000E:
	jmp	userlib::exec

tios::FindSymEntry
util@000F:
	jmp	userlib::FindSymEntry

InitFargoCompatibility:
util@0011:
        ; Copy the font so that the order is correct for Fargo programs
        move.l #6144,-(a7)
        jsr tios::HeapAlloc
        add.l #4,a7
        move.w d0,SF_font_handle
        tst.w d0
        beq ifcEnd
        DEREF d0,a1
        move.l #$407a80,a0
        move.l #383,d0
smallFontCopy:
        move.l (a0)+,(a1)+
        dbra d0,smallFontCopy
        move.l #$407280,a0
        move.l #511,d0
medFontCopy:
        move.l (a0)+,(a1)+
        dbra d0,medFontCopy
        move.l #$408080,a0
        move.l #639,d0
largeFontCopy:
        move.l (a0)+,(a1)+
        dbra d0,largeFontCopy
ifcEnd:
        rts

DeinitFargoCompatibility:
util@0012:
        tst.w SF_font_handle
        beq dfcEnd
        move.w SF_font_handle,-(a7)
        jsr tios::HeapFree
        add.l #2,a7
dfcEnd:
        rts

        cnop 0,4

;*****************************************************
; miscellaneous program data
;*****************************************************

SF_font_handle  dc.w    0
util@0013:
SF_font         dc.l    0
util@0010:
rand_seed	dc.w	0
;oldint0         dc.l    0
charstr         dc.b    0,0
;old_font        dc.w    0
;dialog_pos      ds.w    4
;zeroes		dcb.l	15,0
;save            dc.l    0
;filesearch      ds.l    2
;ioks            ds.b    10

        end
